// -*- C++ -*-
/*!
 * @file  DFIT_Cal.cpp for PW
 * @date  $Date$
 *
 * $Id$
 */

#define _USE_MATH_DEFINES
#include "DFIT_Cal.h"

/*
 *  Default Constructor
 */

DFIT_Cal::DFIT_Cal(void) {
	InitIPExt();			//IP7000BD
	DisableIPErrorMessage();			//G[ɏ𒆒f@\off
	this->CheckError( SelectCamera( CAMERA_PORT0, HITACHI_KPF3W ));					//Jݒ
	this->CheckError( SetVideoFrame( NONINTERLACE_1N , VIDEO_FS_640H_480V ));		//摜t[ݒ
	this->CheckError( SetTrigerMode( TRIGER ));										//Vb^[Xs[hgK[[h
	this->CheckError( SetShutterSpeed( SHUT_1000 ));								//Vb^[Xs[hݒ
	this->CheckError( tm_data.Img[0].R = AllocImg( IMG_FS_640H_512V ));				//{[hɉ摜̈m
	this->CheckError( tm_data.Img[1].R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Img[2].R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[0].R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[1].R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[2].R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Sft.R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Dst.R = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Img[0].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Img[1].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Img[2].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[0].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[1].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.ImgB[2].L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Sft.L = AllocImg( IMG_FS_640H_512V ));
	this->CheckError( tm_data.Dst.L = AllocImg( IMG_FS_640H_512V ));
	IP_ClearAllImg();			//摜̈̏

	time(&SystemTime);	//̎擾
	struct tm* time_struct = localtime(&SystemTime);
	st_sec = time_struct->tm_hour * 3600 + time_struct->tm_min * 60 + time_struct->tm_sec;
	st_sec *= 1000000000;	//imZbN
	QueryPerformanceFrequency(&st_freq);	//NbNpX擾
	QueryPerformanceCounter(&st_init);		//JE^̏l擾
}
/*
 *  Destructor
 */

DFIT_Cal::~DFIT_Cal(void) {
	CloseHandle(this->m_TPMthread);
	CloseHandle(this->m_Odmetry);		//Xbh
	this->tm_data.TPMlog.close();		//Ot@C
}
/*
 *  int DFIT_Cal::CheckError(int ret)
 */
int DFIT_Cal::CheckError(int ret) {		//G[
	if(ret==-1){						//IP7000R}hG[̎̏(IP7000̓G[-1Ԃ)
		ReadIPErrorTable(&Tbl);			//G[
		this->tm_data.TPMlog << ",ErrorCode:" << Tbl.ErrorCode;		//G[R[hOɋL
	}
	return ret;
}

/*
 *	void DFIT_Cal::Configuration(std::string m_FileName, int m_CAMERA_DIS, double m_MPPR, double m_MPPL)
 */
void DFIT_Cal::Configuration(std::string m_FileName, int m_CAMERA_DIS, double m_MPPR, double m_MPPL) {		//RtBO[VݒKp
	this->tm_data.FileName = m_FileName;
	this->tm_data.CAMERA_DIS = m_CAMERA_DIS;
	this->tm_data.MPPR = m_MPPR;
	this->tm_data.MPPL = m_MPPL;
}
/*
 *  void DFIT_Cal::TPmatching(enum TPMmode_mode)
 */
void DFIT_Cal::TPmatching() {			//ev[g}b`OJn
	this->cnt.SignOperation = 1;			//ev[go^C֒l͕tŏ
	this->cnt.ReturnValueOfSetCorrTemplate = 1;	//ev[go^CԂl𕪎Ulɂ
	SetCorrControl(&cnt);						//Lݒ
	this->tm_data.Threshold = 0.30f;
	wait_TMP = CreateEvent(NULL,FALSE,FALSE,NULL);								//{[h̏ItOpCxg
	this->m_TPMthread=(HANDLE)_beginthreadex(NULL,0,TPMthread,this,0,&id_tpm);	//摜pXbhJn
	this->m_Odmetry=(HANDLE)_beginthreadex(NULL,0,ODMthread,this,0,&id_tpm);	//vZpXbhJn
}
/*
 *  void DFIT_Cal::GetPosition(double &px, double &py, double &ptheta)
 */
void DFIT_Cal::GetPosition(double &px, double &py, double &ptheta, double &timestamp) {		//Zof[^n
	px = this->tm_data.pos.x;
	py = this->tm_data.pos.y;
	ptheta = this->tm_data.pos.theta;

	QueryPerformanceCounter(&st_time);
	timestamp = st_sec + (st_time.QuadPart - st_init.QuadPart) * 1000000000 / st_freq.QuadPart;
	return;
}
/*
 *  void DFIT_Cal::ResetPosition(void)
 */
void DFIT_Cal::ResetPosition(void) {		//ZbgďĊJ
	CloseHandle(this->m_Odmetry);
	this->m_Odmetry=(HANDLE)_beginthreadex(NULL,0,ODMthread,this,0,&id_tpm);		//vZpXbhJȂ

}
/*
 *  void DFIT_Cal::Stop(void)
 */
void DFIT_Cal::Stop(void) {		//𒆎~
	CloseHandle(this->m_TPMthread);
	CloseHandle(this->m_Odmetry);
}

unsigned __stdcall DFIT_Cal::TPMthread(void* myself)	//摜pXbhD{[hɏR}hnĂ
{
	int ret,tsx,tsy,tex,tey,ssx,ssy,sex,sey;//摜R}h̕ԂlCev͈́CT[`͈͗pϐ
	unsigned char tem;						//13DO摜̃ev[g㏑Ȃ悤3̉摜̈񂵂Ă
	unsigned char Sspeed_R = 3;
	unsigned char Sspeed_L = 3;
	unsigned char Sspeed_now_R = 3;
	unsigned char Sspeed_now_L = 3;			//Vb^[Xs[hpϐCl=2ms
	char pixeldata=127;						//Vb^[Xs[h̃sNZ擾pϐ

	IPCorrTbl Result_Corr_R,Result_Corr_L;	//ev[g}b`OʗpDx,y,֒l
	IPErrorTbl	Tbl;						//G[R[hp
	DFIT_Cal* _THIS = (DFIT_Cal*)myself;

	tem = 0;

	tsx = (XSIZE - X_TEMP_SIZE) / 2 +1;		//ev[g͈
	tsy = (YSIZE - Y_TEMP_SIZE) / 2 +1;
	tex = (XSIZE + X_TEMP_SIZE) / 2;
	tey = (YSIZE + Y_TEMP_SIZE) / 2;
	ssx = (XSIZE - X_SEARCH_SIZE) / 2 +1;	//T[`͈
	ssy = (YSIZE - Y_SEARCH_SIZE) / 2 +1;
	sex = (XSIZE + X_SEARCH_SIZE) / 2;
	sey = (YSIZE + Y_SEARCH_SIZE) / 2;

	_THIS->tm_data.x.R=0;	//ϐ
	_THIS->tm_data.y.R=0;
	_THIS->tm_data.x.L=0;
	_THIS->tm_data.y.L=0;
	Result_Corr_R.X = 0;
	Result_Corr_R.Y = 0;
	Result_Corr_L.X = 0;
	Result_Corr_L.Y = 0;

	SetCorrMode( SPIRAL_STOP, 1, _THIS->tm_data.Threshold);	//TPMT[`[h̐ݒ

	_THIS->tm_data.Src.R = _THIS->tm_data.Img[tem].R;	//摜̈񂷁Dtem=1`3
	_THIS->tm_data.Src.L = _THIS->tm_data.Img[tem].L;
	_THIS->tm_data.Bin.R = _THIS->tm_data.ImgB[tem].R;
	_THIS->tm_data.Bin.L = _THIS->tm_data.ImgB[tem].L;

	_THIS->Check(Get2Camera( _THIS->tm_data.Src.R, _THIS->tm_data.Src.L ));				//摜擾

	QueryPerformanceCounter(&_THIS->st_time);	//JE^l擾

	IP_Shift( _THIS->tm_data.Src.R, _THIS->tm_data.Sft.R, 1, 1, SPACE_NOTOUCH );	//FVtg
	IP_Sub( _THIS->tm_data.Src.R, _THIS->tm_data.Sft.R, _THIS->tm_data.Dst.R);			//FZ
	IP_Binarize( _THIS->tm_data.Dst.R, _THIS->tm_data.Bin.R, 1);					//Fl
	ChangeImgDataType( _THIS->tm_data.Bin.R , UNSIGN8_DATA );					//lf[^8bitf[^ɕϊ
	IP_Shift( _THIS->tm_data.Src.L, _THIS->tm_data.Sft.L, 1, 1, SPACE_NOTOUCH );
	IP_Sub( _THIS->tm_data.Src.L, _THIS->tm_data.Sft.L, _THIS->tm_data.Dst.L);
	IP_Binarize( _THIS->tm_data.Dst.L, _THIS->tm_data.Bin.L, 1);	
	ChangeImgDataType( _THIS->tm_data.Bin.L , UNSIGN8_DATA );
	_THIS->tm_data.Tempo.R = _THIS->tm_data.Src.R;
	_THIS->tm_data.Tempo.L = _THIS->tm_data.Src.L;
	_THIS->tm_data.Src.R = _THIS->tm_data.Bin.R;
	_THIS->tm_data.Src.L = _THIS->tm_data.Bin.L;

	SetWindow( SRC0_WIN, tsx, tsy, tex, tey );
		SaveBMPFile ( _THIS->tm_data.Src.R , "FirstImgR.bmp" , BW_BITMAP );		//Jn̘Hʉ摜bmpۑ
		SaveBMPFile ( _THIS->tm_data.Src.L , "FirstImgL.bmp" , BW_BITMAP );
	ret = _THIS->Check( SetCorrTemplateExt( _THIS->tm_data.Src.R, 1, XMAG, YMAG ));
	ret = _THIS->Check( SetCorrTemplateExt( _THIS->tm_data.Src.L, 2, XMAG, YMAG ));
	ResetAllWindow();

	tem++;
	_THIS->tm_data.Src.R = _THIS->tm_data.Img[tem].R;
	_THIS->tm_data.Src.L = _THIS->tm_data.Img[tem].L;
	_THIS->tm_data.Bin.R = _THIS->tm_data.ImgB[tem].R;
	_THIS->tm_data.Bin.L = _THIS->tm_data.ImgB[tem].L;

	while(1){
		if(ret!=-1) ret = Get2Camera( _THIS->tm_data.Src.L,_THIS->tm_data.Src.R );
		
		QueryPerformanceCounter(&_THIS->st_time);	//JE^l擾
		
		if(ret!=-1) ret = IP_Shift( _THIS->tm_data.Src.R, _THIS->tm_data.Sft.R, 1, 1, SPACE_NOTOUCH );	//FVtg
		if(ret!=-1) ret = IP_Sub( _THIS->tm_data.Src.R, _THIS->tm_data.Sft.R, _THIS->tm_data.Dst.R);			//FZ
		if(ret!=-1) ret = IP_Binarize( _THIS->tm_data.Dst.R, _THIS->tm_data.Bin.R, 1);					//Fl
		if(ret!=-1) ret = ChangeImgDataType( _THIS->tm_data.Bin.R , UNSIGN8_DATA );				//lf[^8bitf[^ɕϊ
		if(ret!=-1) ret = IP_Shift( _THIS->tm_data.Src.L, _THIS->tm_data.Sft.L, 1, 1, SPACE_NOTOUCH );
		if(ret!=-1) ret = IP_Sub( _THIS->tm_data.Src.L, _THIS->tm_data.Sft.L, _THIS->tm_data.Dst.L);
		if(ret!=-1) ret = IP_Binarize( _THIS->tm_data.Dst.L, _THIS->tm_data.Bin.L, 1);	
		if(ret!=-1) ret = ChangeImgDataType( _THIS->tm_data.Bin.L , UNSIGN8_DATA );
		_THIS->tm_data.Tempo.R = _THIS->tm_data.Src.R;
		_THIS->tm_data.Tempo.L = _THIS->tm_data.Src.L;
		_THIS->tm_data.Src.R = _THIS->tm_data.Bin.R;
		_THIS->tm_data.Src.L = _THIS->tm_data.Bin.L;
		
		if(ret!=-1) ret = SetCorrBreakThr(0);	//SSDA@
		if(ret!=-1) ret = EnableCorrBreak();	//ł؂苖

		if(ret!=-1) ret = SetWindow( SRC0_WIN, ssx, ssy, sex, sey );	//͈͐ݒ
		_THIS->tm_data.ret.R = IP_Corr( _THIS->tm_data.Src.R, 1, &Result_Corr_R );	//TPME
		_THIS->tm_data.ret.L = IP_Corr( _THIS->tm_data.Src.L, 2, &Result_Corr_L );	//TPM
		if(ret!=-1) ret = ResetAllWindow();								//͈͐ݒ

		if(_THIS->tm_data.ret.R!=1){	//̂Ȃev[g擾ꍇɃVb^[Xs[hύX
			SetPixelPointer( _THIS->tm_data.Tempo.R );	//摜1fANZXʐݒ
			ReadPixel( 320, 240, &pixeldata );	//1f̃f[^擾
			//Vb^[x
			if(pixeldata<0);
			else if(pixeldata<=20){			//ʂ^̂Ƃ
				if(Sspeed_R == 5);//ȏ㑬łȂꍇ
				else Sspeed_R++;//Vb^[Xs[hx(ʑ)
			}
			else if(pixeldata>=240){		//ʂ^̂Ƃ
					if(Sspeed_R == 0);//ȏxłȂꍇ
					else Sspeed_R--;//Vb^[Xs[h𑬂(ʌ)
			}
		}

		if(_THIS->tm_data.ret.L!=1){	//̂Ȃev[g擾ꍇɃVb^[Xs[hύX
			SetPixelPointer( _THIS->tm_data.Tempo.L );	//摜1fANZXʐݒ
			ReadPixel( 320, 240, &pixeldata );	//1f̃f[^擾
			//Vb^[x
			if(pixeldata<0);
			else if(pixeldata<=20){			//ʂ^̂Ƃ
				if(Sspeed_L == 5);//ȏ㑬łȂꍇ
				else Sspeed_L++;//Vb^[Xs[hx(ʑ)
			}
			else if(pixeldata>=240){		//ʂ^̂Ƃ
					if(Sspeed_L == 0);//ȏxłȂꍇ
					else Sspeed_L--;//Vb^[Xs[h𑬂(ʌ)
			}
		}
		
		//Vb^[Xs[h
		if( Sspeed_R != Sspeed_now_R){	//Vb^[Xs[hp[^̍XVΉVb^[Xs[hɕύX
			switch(Sspeed_R){
				case 0:	SetShutterSpeedMltPort(0,SHUT_4000 );	break;//Vb^[Xs[hŒx
				case 1:	SetShutterSpeedMltPort(0,SHUT_2000 );	break;
				case 2:	SetShutterSpeedMltPort(0,SHUT_1000 );	break;
				case 3:	SetShutterSpeedMltPort(0,SHUT_500 );	break;
				case 4:	SetShutterSpeedMltPort(0,SHUT_250 );	break;
				case 5:	SetShutterSpeedMltPort(0,SHUT_125 );	break;//Vb^[Xs[hő
			}
			Sspeed_now_R = Sspeed_R;
		}
		if( Sspeed_L != Sspeed_now_L){	//Vb^[Xs[hp[^̍XVΉVb^[Xs[hɕύX
			switch(Sspeed_L){
				case 0:	SetShutterSpeedMltPort(1,SHUT_4000 );	break;//Vb^[Xs[hŒx
				case 1:	SetShutterSpeedMltPort(1,SHUT_2000 );	break;
				case 2:	SetShutterSpeedMltPort(1,SHUT_1000 );	break;
				case 3:	SetShutterSpeedMltPort(1,SHUT_500 );	break;
				case 4:	SetShutterSpeedMltPort(1,SHUT_250 );	break;
				case 5:	SetShutterSpeedMltPort(1,SHUT_125 );	break;//Vb^[Xs[hő
			}
			Sspeed_now_L = Sspeed_L;
		}

		if(ret!=-1) ret = SetWindow( SRC0_WIN, tsx, tsy, tex, tey );			//TP͈͐ݒ
		_THIS->Check(SetCorrTemplateExt( _THIS->tm_data.Src.R, 1, XMAG, YMAG ));	//TPo^E
		_THIS->Check(SetCorrTemplateExt( _THIS->tm_data.Src.L, 2, XMAG, YMAG ));	//TPo^
		if(ret!=-1) ret = ResetAllWindow();										//͈͐ݒ

		if(ret==-1){														//G[
			ReadIPErrorTable(&Tbl);											//G[
			_THIS->tm_data.TPMlog << "ErrorCode:" << Tbl.ErrorCode << std::endl;	//G[R[hOɋL
		}

		tem++;	if(tem >= 3)	tem = 0;		//摜̈
		_THIS->tm_data.Src.R = _THIS->tm_data.Img[tem].R;
		_THIS->tm_data.Src.L = _THIS->tm_data.Img[tem].L;
		_THIS->tm_data.Bin.R = _THIS->tm_data.ImgB[tem].R;
		_THIS->tm_data.Bin.L = _THIS->tm_data.ImgB[tem].L;

		_THIS->tm_data.x.R = Result_Corr_R.X - tsx;	//TPMʑ
		_THIS->tm_data.y.R = Result_Corr_R.Y - tsy;
		_THIS->tm_data.x.L = Result_Corr_L.X - tsx;
		_THIS->tm_data.y.L = Result_Corr_L.Y - tsy;
		_THIS->tm_data.v = Result_Corr_R.VALUE;
				
		SetEvent(_THIS->wait_TMP);						//摜I
	}

}

unsigned __stdcall DFIT_Cal::ODMthread(void* myself)
{
	LARGE_INTEGER timer_tpm[2], timer_cal, freq;	//Ԍvpϐ
	LONGLONG total_time;		//Ԍvpϐ
	double time_tpm,time_cal;	//Ԍvpϐ
	BOOL swt = 0;				//Ԍvpϐ
	DFIT_Cal* _THIS = (DFIT_Cal*)myself;

	//vOɋL^
	int mag_x = XMAG;
	int mag_y = YMAG;
	int Img_x = XSIZE;
	int Img_y = YSIZE;
	int tempsize_x = X_TEMP_SIZE;
	int tempsize_y = Y_TEMP_SIZE;
	int searchsize_x = X_SEARCH_SIZE;
	int searchsize_y = Y_SEARCH_SIZE;
	int CameraDis = _THIS->tm_data.CAMERA_DIS;
	double mmParPulsR = _THIS->tm_data.MPPR;
	double mmParPulsL = _THIS->tm_data.MPPL;

	_THIS->tm_data.TPMlog<<"Image size = "<< Img_x <<"x"<< Img_y << std::endl;
	_THIS->tm_data.TPMlog<<"SearchArea = "<< searchsize_x <<"x"<< searchsize_y << std::endl;
	_THIS->tm_data.TPMlog<<"temp size = "<< tempsize_x <<"x"<< tempsize_y <<"(mag:"<< mag_x <<":"<< mag_y <<")"<< std::endl;
	_THIS->tm_data.TPMlog<<"Cameras distance,"<< CameraDis << std::endl;
	_THIS->tm_data.TPMlog<<"mm par Puls L,"<< mmParPulsL << std::endl;
	_THIS->tm_data.TPMlog<<"mm par Puls R,"<< mmParPulsR << std::endl;
	_THIS->tm_data.TPMlog<<"TPM Threshold,"<< _THIS->tm_data.Threshold << std::endl;

	//
	_THIS->tm_data.pos.x = 0;
	_THIS->tm_data.pos.y = 0;
	_THIS->tm_data.pos.theta = 0;
	_THIS->tm_data.TPMlog<<"xL,yL,xR,yR,retL,retR,Value,PosX,PosY,PosTheta,TPMTime(micro sec),CalculateTime(micro sec)";
	if( !QueryPerformanceFrequency( &freq ) ){		//CPUg擾
		_THIS->tm_data.TPMlog << "Ԍvł܂" << std::endl;
	}
	Sleep(1000);
	QueryPerformanceCounter( &timer_tpm[1] );		//Ԍvl
	QueryPerformanceCounter( &timer_cal );			//Ԍvl

	while(1){
		WaitForSingleObject(_THIS->wait_TMP,INFINITE);		//摜Îm点҂
		QueryPerformanceCounter( &timer_tpm[swt] );	//Ԍv(摜I)
		total_time = ( timer_tpm[swt].QuadPart - timer_tpm[~swt].QuadPart )*1000000 / freq.QuadPart;	//񎞊-O񎞊
		time_tpm = (double)total_time;
		total_time = ( timer_cal.QuadPart - timer_tpm[~swt].QuadPart )*1000000 / freq.QuadPart;			//OvZI-OvJn
		time_cal = (double)total_time;
		swt = ~swt;

		_THIS->Odmetry();	//IhgvZ

		//OL
		_THIS->tm_data.TPMlog<<"\n"<<_THIS->tm_data.x.L<<","<<_THIS->tm_data.y.L<<","<<_THIS->tm_data.x.R<<","<<_THIS->tm_data.y.R<<","<<_THIS->tm_data.ret.L<<","<<_THIS->tm_data.ret.R<<","<<_THIS->tm_data.v<<","<<_THIS->tm_data.pos.x<<","<<_THIS->tm_data.pos.y<<","<<_THIS->tm_data.pos.theta<<","<<time_tpm<<","<<time_cal;
		QueryPerformanceCounter( &timer_cal );			//Ԍv(vZI)
	}
}

int DFIT_Cal::Check(int ret){	//G[
	IPErrorTbl	Tbl;
	if(ret==-1){
		ReadIPErrorTable(&Tbl);
	}
	return ret;
}

void DFIT_Cal::Odmetry(){	//IhgvZ
	double disX_l,disY_l,disX_r,disY_r;	//J̕ψʋ[mm]
	double disX,disY;					//S_̕ψʋ[mm]
	double disRot;						//ψʊpx[rad]

	//lPʂɕϊ
	disX_l = -this->tm_data.MPPL * this->tm_data.x.L;
	disY_l = this->tm_data.MPPL * this->tm_data.y.L;
	disX_r = this->tm_data.MPPR * this->tm_data.x.R;
	disY_r = -this->tm_data.MPPR * this->tm_data.y.R;

	//ψʊpx߂
	//disRot =  (disX_l - disX_r)*180 / (this->tm_data.CAMERA_DIS*M_PI);
	disRot =  (disX_l - disX_r) / (this->tm_data.CAMERA_DIS);
	
	//S_̕ψʂ߂
	disX = ( disY_l + disY_r ) / 2;
	disY = ( disX_l + disX_r ) / 2;

	//px߂
	this->tm_data.pos.theta += disRot;
	//if(abs(this->tm_data.pos.theta)>360){this->tm_data.pos.theta=fmod(this->tm_data.pos.theta,360);}
	//if(this->tm_data.pos.theta<0){this->tm_data.pos.theta+=360;}//px0-360͈̔͂ɕϊ

	//W߂
	//this->tm_data.pos.x += disX * cos((this->tm_data.pos.theta)*M_PI/180) + disY * sin((this->tm_data.pos.theta)*M_PI/180);
	//this->tm_data.pos.y += disY * cos((this->tm_data.pos.theta)*M_PI/180) + disX * sin((this->tm_data.pos.theta)*M_PI/180);
	this->tm_data.pos.x += disX * cos(this->tm_data.pos.theta) + disY * sin(this->tm_data.pos.theta);
	this->tm_data.pos.y += disY * cos(this->tm_data.pos.theta) + disX * sin(this->tm_data.pos.theta);


	double theta_deg = tm_data.pos.theta * 180 / M_PI;
	if(abs(this->tm_data.pos.theta)>360){theta_deg = fmod(this->tm_data.pos.theta,360);}
	if(this->tm_data.pos.theta<0){theta_deg += 360;}//px0-360͈̔͂ɕϊ

	std::cout << "[L]:" << this->tm_data.ret.L << ",[R]:" << this->tm_data.ret.R << ",[X]:" 
		<< this->tm_data.pos.x << ",[Y}:" << this->tm_data.pos.y << ",[THETA]:" << theta_deg << std::endl;
}